{% extends '@admin/default_frame.twig' %}

{% set menus = ['manufacturer', 'manufacturer_master'] %}

{% block title %}製造者一覧{% endblock %}
{% block sub_title %}製造者管理{% endblock %}


{% form_theme searchForm '@admin/Form/bootstrap_4_layout.html.twig' %}

{% block javascript %}
    <script>
        $(function() {
            $('#bulkDelete').on('click', function() {

                var modal = $('#bulkDeleteModal');

                // 削除中のUI変更処理
                modal.find('button').attr('disabled', 'disabled');
                $('.modal-body p', modal).text("{{ 'admin.manufacturer.delete_manufacturer.processing'|trans }}");
                $('.progress', modal).show();

                var checkedList = $('input[type=checkbox][data-delete-url]:checked');
                var totalCount = checkedList.length;
                var currentCount = 0;

                var promises = checkedList.map(function() {
                    return $.ajax({
                        'url': $(this).data('delete-url'),
                        'type': 'delete',
                        'data': {'_token': $(this).attr('token-for-anchor')}
                    }).always(function() {
                        $('.progress-bar', modal).css('width', (++currentCount / totalCount * 100) + '%');
                    });
                });

                var addError = function(errorMessage) {
                    $('<li><span class="badge bg-danger">ERROR</span> </li>')
                        .append($('<span></span>').text(errorMessage))
                        .appendTo('#bulkErrors');
                };

                $.when.apply($, promises)
                    .done(function() {
                        // 削除できなかった場合はエラーメッセージを表示
                        var args = promises.length === 1 ? [arguments[0]] : [].slice.call(arguments).map(function(result) {
                            return result[0];
                        });
                        args.filter(function(result) {
                            return result.success === false;
                        }).forEach(function(result) {
                            addError(result.message);
                        });
                    })
                    .fail(function() {
                        // システムエラー
                        addError("{{ 'admin.manufacturer.permanently_delete__system_error'|trans }}");
                    })
                    .always(function() {
                        $('.progress', modal).hide();
                        $('.modal-body p', modal).text("{{ 'admin.manufacturer.permanently_delete__complete_message'|trans }}");
                        modal.find('button').removeAttr('disabled').toggle();
                    })
            });

            $('#bulkDeleteDone').on('click', function() {
                location.reload(true);
            });

            toggleBtnBulk('input[id^="check_"]', '#btn_bulk');
            $('input[id^="check_"]').on('change', function() {
                $('#trigger_check_all').prop('checked', false);
                toggleBtnBulk('input[id^="check_"]', '#btn_bulk');
            });

            $('#trigger_check_all').on('change', function() {
                var checked = $(this).prop('checked');
                if (checked) {
                    $('input[id^="check_"]').prop('checked', true);
                } else {
                    $('input[id^="check_"]').prop('checked', false);
                }
                toggleBtnBulk('input[id^="check_"]', '#btn_bulk');
            });

            $('#form_bulk').find('.action-submit').on('click', function(event) {
                event.preventDefault();
                var form = $(this).closest('form');
                if (!form.find('input:checkbox[name^="ids"]:checked').length) {
                    {# TODO: should use modal instead of alert #}
                    alert('please check');
                    return false;
                }

                $('<input />').attr('type', 'hidden').attr('name', '{{ constant('Eccube\\Common\\Constant::TOKEN_NAME') }}')
                    .val($(this).attr('token-for-anchor'))
                    .appendTo(form);
                form.attr('action', $(this).data('action')).submit();
                return false;
            });

            var dataClass = [];
            var modalClass = $('#productClassesModal');
            $('form#form_bulk').on('click', 'table.table button[data-class-url]', function() {
                var btnClass = $(this);
                btnClass.attr('disabled', true);
                var productId = btnClass.data('product-id');

                if (dataClass[productId] != undefined) {
                    renderClass(dataClass[productId], btnClass);
                    return;
                }

                $.ajax({
                    url: btnClass.data('class-load'),
                    type: 'GET',
                }).done(function(data) {
                    dataClass[productId] = data;
                    renderClass(dataClass[productId], btnClass);
                }).fail(function() {
                    alert('Failed');
                });
            });

            // Append html and show popup
            function renderClass(data, btnClass) {
                $('div.modal-body', modalClass).html(data);
                $('h5.modal-title', modalClass).text(btnClass.data('message'));
                $('a.btn-ec-conversion', modalClass).attr('href', btnClass.data('class-url'));
                modalClass.modal('show');
                btnClass.attr('disabled', false);
            }
        });
    </script>
{% endblock javascript %}

{% block main %}
    <div class="c-outsideBlock">
        <form id='search_form' method="post" action="{{ url('admin_manufacturer') }}">
            {{ form_widget(searchForm._token) }}
            <div class="c-outsideBlock__contents">
                <div class="row justify-content-start">

                    <div class="col-6">
                        <div class="mb-2">
                            <label class="col-form-label" data-bs-toggle="tooltip" data-bs-placement="top" title="{{ 'tooltip.product.multi_search_label'|trans }}">{{ 'admin.manufacturer.multi_search_label'|trans }}<i class="fa fa-question-circle fa-lg ms-1"></i></label>
                            {{ form_widget(searchForm.id) }}
                            {{ form_errors(searchForm.id) }}
                        </div>
                    </div>
                </div>
            </div>
            <div class="c-outsideBlock__contents mb-5">
                <button class="btn btn-ec-conversion px-5" type="submit">{{ 'admin.common.search'|trans }}</button>
                {% if pagination %}
                    <span class="fw-bold ms-2">{{ 'admin.common.search_result'|trans({"%count%":pagination.totalItemCount})|raw }}</span>
                {% endif %}
            </div>
            {{ form_widget(searchForm.sortkey, {'attr': {'class': 'js-listSort-key'}}) }}
            {{ form_widget(searchForm.sorttype, {'attr': {'class': 'js-listSort-type'}}) }}
        </form>
    </div>
    <div class="c-contentsArea__cols">
        <div class="c-contentsArea__primaryCol">
            <div class="c-primaryCol">
                {% if pagination and pagination.totalItemCount %}
                  {# {% if Manufacturers %} #}
                    <form id="form_bulk" method="POST" action="">
                        <div class="row justify-content-between mb-2">
                            <div class="col-6">
                                <div id="btn_bulk" class="d-none">
                                    <label class="me-2">{{ 'admin.common.bulk_actions'|trans }}</label>
                                    {# <div class="btn-group me-2" role="group">
                                        <button {{ csrf_token_for_anchor() }} data-action="{{ url('admin_manufacturer_bulk_manufacturer_status', {id: constant('Customize\\Entity\\Master\\manufacturerStatus::DISPLAY_SHOW')}) }}" class="btn btn-ec-regular action-submit" type="button">
                                            <span>{{ 'admin.product.display_status__show'|trans }}</span>
                                        </button>
                                        <button {{ csrf_token_for_anchor() }} data-action="{{ url('admin_manufacturer_bulk_manufacturer_status', {id: constant('Customize\\Entity\\Master\\manufacturerStatus::DISPLAY_HIDE')}) }}" class="btn btn-ec-regular action-submit" type="button">
                                            <span>{{ 'admin.product.display_status__hide'|trans }}</span>
                                        </button>
                                    </div>
                                    <button {{ csrf_token_for_anchor() }} data-action="{{ url('admin_manufacturer_bulk_manufacturer_status', {id: constant('Customize\\Entity\\Master\\manufacturerStatus::DISPLAY_ABOLISHED')}) }}" class="btn btn-ec-regular me-2 action-submit">
                                        {{ 'admin.product.display_status__abolished'|trans }}
                                    </button> #}
                                    <button type="button" data-bs-toggle="modal" data-bs-target="#bulkDeleteModal" class="btn btn-ec-delete">{{ 'admin.product.permanently_delete'|trans }}</button>
                                </div>
                            </div>
                            <div class="col-5 text-end">
                                <div class="d-inline-block me-2 align-bottom">
                                    <div>
                                        <select class="form-select" onchange="location = this.value;">
                                            {% for pageMax in pageMaxis %}
                                                <option {% if pageMax.name == page_count %}selected=""{% endif %} value="{{ path('admin_manufacturer_page', {'page_no': 1, 'page_count': pageMax.name}) }}">{{ 'admin.common.count'|trans({ '%count%': pageMax.name }) }}</option>
                                            {% endfor %}
                                        </select>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="card rounded border-0 mb-4 d-block">
                            <div class="card-body p-0">
                                <table class="table table-sm">
                                    <thead>
                                    <tr>
                                        <th class="border-top-0 ps-3 pt-2 pb-2">
                                            <input type="checkbox" name="filter" value="open" id="trigger_check_all">
                                        </th>
                                        <th class="border-top-0 pt-2 pb-2" nowrap>{{ 'ID'|trans }}<a href="#" class="js-listSort" data-sortkey="manufacturer_id"><i class="fa fa-arrow-up" aria-hidden="true"></i></a></th>
                                        <th class="border-top-0 pt-2 pb-2">{{ 'admin.product.image__short'|trans }}</th>
                                        <th class="border-top-0 pt-2 pb-2">{{ '名'|trans }}</th>
                                        <th class="border-top-0 pt-2 pb-2">{{ '住所'|trans }}</th>
                                        <th class="border-top-0 pt-2 pb-2">{{ 'メール'|trans }}</th>
                                        <th class="border-top-0 pt-2 pb-2">{{ '電話番号'|trans }}</th>
                                        <th class="border-top-0 pt-2 pb-2">{{ 'admin.common.create_date'|trans }}<a href="#" class="js-listSort" data-sortkey="create_date"><i class="fa fa-arrow-up" aria-hidden="true"></i></a></th>
                                        <th class="border-top-0 pt-2 pb-2">{{ 'admin.common.update_date'|trans }}<a href="#" class="js-listSort" data-sortkey="update_date"><i class="fa fa-arrow-up" aria-hidden="true"></i></a></th>
                                        <th class="border-top-0 pt-2 pb-2 pe-3" colspan="3"></th>
                                    </tr>
                                    </thead>
                                    <tbody>
                                    {% for Manufacturer in pagination %}
                                        <tr id="ex-product-{{ Manufacturer.id }}">
                                            <td class="align-middle ps-3">
                                                <input type="checkbox" name="ids[]" value="{{ Manufacturer.id }}" id="check_{{ Manufacturer.id }}" data-delete-url="{{ url('admin_product_product_delete', { id: Manufacturer.id }) }}">
                                            </td>
                                            <td class="align-middle">{{ Manufacturer.id }}</td>
                                            <td class="align-middle">
                                                <a href="{{ url('admin_manufacturer_manufacturer_edit', { id : Manufacturer.id }) }}">
                                                    <img src="{{ asset(Manufacturer.mainFileName|no_image_product, 'save_image') }}"
                                                         style="max-width: 50px">
                                                </a>
                                            </td>
                                            <td class="align-middle"><a
                                                        href="{{ url('admin_manufacturer_manufacturer_edit', { id : Manufacturer.id }) }}">{{ Manufacturer.__toString }}</a>
                                            </td>
                                             <td class="align-middle">
                                                {{ Manufacturer.Pref }}
                                            </td>
                                             <td class="align-middle">
                                                {{ Manufacturer.email }}
                                            </td>
                                             <td class="align-middle">
                                                {{ Manufacturer.phone_number }}
                                            </td>
                                            <td class="align-middle">
                                                {{ Manufacturer.create_date|date_min }}
                                            </td>
                                            <td class="align-middle">
                                                {{ Manufacturer.update_date|date_min }}
                                            </td>
                                            <td class="align-middle pe-3" colspan="3">
                                                <div class="text-end">
                                                    <div class="px-1 d-inline-block text-center" data-bs-toggle="tooltip"
                                                         data-bs-placement="top"
                                                         title="{{ 'admin.common.display'|trans }}"><a class="btn btn-ec-actionIcon"
                                                                                                       href="#"
                                                                                                       target="_blank"><i
                                                                    class="fa fa-eye fa-lg text-secondary"
                                                                    aria-hidden="true"></i></a></div>
                                                    <div class="px-1 d-inline-block text-center" data-bs-toggle="tooltip"
                                                         data-bs-placement="top"
                                                         title="{{ 'admin.common.copy'|trans }}">
                                                        <a href="#" class="btn btn-ec-actionIcon"
                                                           data-bs-toggle="modal"
                                                           data-bs-target="#confirmModal-{{ Manufacturer.id }}">
                                                            <i class="fa fa-files-o fa-lg text-secondary"
                                                               aria-hidden="true"></i></a>
                                                        <div class="modal fade" id="confirmModal-{{ Manufacturer.id }}" tabindex="-1"
                                                             role="dialog"
                                                             aria-labelledby="confirmModal-{{ Manufacturer.id }}" aria-hidden="true">
                                                            <div class="modal-dialog" role="document">
                                                                <div class="modal-content">
                                                                    <div class="modal-header">
                                                                        <h5 class="modal-title fw-bold">
                                                                            {{ 'admin.manufacturer.duplicate_manufacturer.modal_confirm.title'|trans }}</h5>
                                                                        <button class="btn-close" type="button"
                                                                                data-bs-dismiss="modal"
                                                                                aria-label="Close">
                                                                        </button>
                                                                    </div>
                                                                    <div class="modal-body text-start">
                                                                        <p class="text-start">
                                                                            {{ 'admin.manufacturer.duplicate_manufacturer.modal_confirm.question'|trans }}</p>
                                                                    </div>
                                                                    <div class="modal-footer">
                                                                        <button class="btn btn-ec-sub" type="button"
                                                                                data-bs-dismiss="modal">{{ 'admin.common.cancel'|trans }}
                                                                        </button>
                                                                        {# <a
                                                                                href="{{ url('admin_manufacturer_manufacturer_copy', {'id' : Manufacturer.id}) }}"
                                                                                class="btn btn-ec-conversion"
                                                                                data-confirm="false"
                                                                                {{ csrf_token_for_anchor() }}
                                                                                data-method="post">
                                                                            {{ 'admin.common.copy'|trans }}
                                                                        </a> #}
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </td>
                                        </tr>
                                    {% endfor %}

                                    </tbody>
                                </table>
                            </div>
                            {% if pagination.totalItemCount > 0 %}
                                <div class="row justify-content-md-center mb-4 pb-4">
                                    {% include "@admin/pager.twig" with { 'pages' : pagination.paginationData, 'routes' : 'admin_manufacturer_page' } %}
                                </div>
                            {% endif %}
                        </div>
                    </form>
                {% elseif has_errors %}
                    <div class="card rounded border-0">
                        <div class="card-body p-4">
                            <div class="text-center text-muted mb-4 h5">{{ 'admin.common.search_invalid_condition'|trans }}</div>
                            <div class="text-center text-muted">{{ 'admin.common.search_try_change_condition'|trans }}</div>
                        </div>
                    </div>
                {% else %}
                    <div class="card rounded border-0">
                        <div class="card-body p-4">
                            <div class="text-center text-muted mb-4 h5">{{ 'admin.common.search_no_result'|trans }}</div>
                            <div class="text-center text-muted">{{ 'admin.common.search_try_change_condition'|trans }}</div>
                            <div class="text-center text-muted">{{ 'admin.common.search_try_advanced_search'|trans }}</div>
                        </div>
                    </div>
                {% endif %}
            </div>

            <!-- 完全に削除の確認モーダル-->
            <div class="modal fade" id="bulkDeleteModal" tabindex="-1" role="dialog" aria-labelledby="discontinuance" aria-hidden="true" data-bs-keyboard="false" data-bs-backdrop="static">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title fw-bold">{{ 'admin.manufacturer.delete_manufacturer.modal_confirm.title'|trans }}</h5>
                            <button class="btn-close" type="button" data-bs-dismiss="modal" aria-label="Close"></button>
                        </div>
                        <div class="modal-body text-start">
                            <p class="text-start">{{ 'admin.manufacturer.delete_manufacturer.modal_confirm.question'|trans }}</p>
                            <ul id="bulkErrors"></ul>
                            <div class="progress" style="display: none">
                                <div class="progress-bar progress-bar-striped progress-bar-animated" role="progressbar" style="width: 0%" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100"></div>
                            </div>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-ec-sub" type="button" data-bs-dismiss="modal">{{ 'admin.common.cancel'|trans }}</button>
                            <button class="btn btn-ec-delete" type="button" id="bulkDelete">{{ 'admin.manufacturer.bulk_delete' | trans }}</button>
                            <button class="btn btn-ec-regular" id="bulkDeleteDone" style="display: none" type="button" data-bs-dismiss="modal">{{ 'Delete manufacturer completed'|trans }}</button>
                        </div>
                    </div>
                </div>
            </div>

        </div>
    </div>

    <div class="modal fade" id="productClassesModal" tabindex="-1" role="dialog" aria-labelledby="productClassesModal" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title fw-bold">{# Title #}</h5>
                    <button class="btn-close" type="button" data-bs-dismiss="modal" aria-label="Close">
                    </button>
                </div>
                <div class="modal-body">
                    {# Append data list #}
                </div>
                <div class="modal-footer">
                    <button class="btn btn-v-sub" type="button" data-bs-dismiss="modal">
                        {{ 'admin.common.cancel'|trans }}
                    </button>
                    <a class="btn btn-ec-conversion"
                       href="#">
                        {{ 'admin.product.move_to_product_class'|trans }}
                    </a>
                </div>
            </div><!-- /.modal-content -->
        </div><!-- /.modal-dialog -->
    </div><!-- /#productClassesModal -->
{% endblock %}
